"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBaseconfig = getBaseconfig;
var _webpack = require("webpack");
var path = _interopRequireWildcard(require("path"), true);
var _cssMinimizerWebpackPlugin = require("css-minimizer-webpack-plugin");
var _terserWebpackPlugin = require("terser-webpack-plugin");
var _common = require("@srejs/common");
var _loader = require("./loader");
var _plugin = require("./plugin");
var _entry = require("./entry");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var _getCoreConfig = (0, _common.getCoreConfig)(),
  prefixCDN = _getCoreConfig.prefixCDN;
var rootDir = (0, _common.getOptions)('rootDir');
var srcPath = path.join(_common.cwd + "/".concat(rootDir));
function getBaseconfig(page) {
  var isServer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var hotReload = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  (0, _entry.initEntry)();
  var entryObj = (0, _entry.getEntry)(page);
  var tempObj = {};
  var pluginsObj = [];
  if (hotReload) {
    for (var key in entryObj) {
      tempObj[key] = ['webpack-hot-middleware/client?path=/__webpack_hmr&timeout=10000&reload=true', entryObj[key]];
    }
    pluginsObj = [].concat(_toConsumableArray((0, _plugin.getPlugin)(entryObj, isServer)), [new _webpack.HotModuleReplacementPlugin()]);
  } else {
    tempObj = entryObj;
    pluginsObj = _toConsumableArray((0, _plugin.getPlugin)(entryObj, isServer));
  }
  var config = {
    devtool: (0, _common.isDev)() ? 'eval-source-map' : false,
    mode: (0, _common.isDev)() ? 'development' : 'production',
    optimization: {
      usedExports: true,
      minimize: (0, _common.isDev)() ? false : true,
      /**minimizer 提取css和js压缩 */
      minimizer: [new _cssMinimizerWebpackPlugin(), new _terserWebpackPlugin({
        extractComments: false,
        parallel: true,
        cache: true
      })],
      splitChunks: {
        cacheGroups: {
          vendors: {
            test: /[\\/]node_modules[\\/](vue|vuex|vue-router)[\\/]/,
            name: 'vendor',
            chunks: 'all'
          }
        }
      }
    },
    entry: _objectSpread({}, tempObj),
    //类别入口文件
    output: {
      publicPath: !(0, _common.isDev)() ? prefixCDN : '/',
      libraryTarget: 'umd',
      globalObject: 'this',
      filename: (0, _common.isDev)() || isServer ? '[name].js' : "[name]_[contenthash:8].js",
      //打包后输出文件的文件名
      path: _common.clientDir //打包后的文件存放的地方
    },
    stats: {
      publicPath: false,
      performance: false,
      env: false,
      depth: false,
      colors: true,
      assets: true,
      cachedAssets: false,
      children: false,
      chunks: false,
      modules: false,
      warnings: false,
      entrypoints: false
    },
    module: {
      rules: (0, _loader.loaderRules)(isServer)
    },
    devServer: {
      contentBase: srcPath,
      port: 8080,
      hot: true
    },
    plugins: pluginsObj,
    resolve: {
      modules: [path.resolve(__dirname, '../../node_modules'), 'node_modules'],
      extensions: ['.js', '.jsx', '.ts', '.tsx', '.vue', 'css', '.scss', '.less'],
      alias: {
        '@': srcPath,
        components: srcPath + '/components',
        images: srcPath + '/images',
        vue: path.resolve(_common.cwd, './node_modules/vue'),
        'vue-router': path.resolve(_common.cwd, './node_modules/vue-router')
      }
    }
  };
  return config;
}